# ---------------------------------------------------------------------------------
#  /\_/\  🌐 This module was loaded through https://t.me/hikkamods_bot
# ( o.o )  🔐 Licensed under the GNU GPLv3.
#  > ^ <   ⚠️ Owner of heta.hikariatama.ru doesn't take any responsibilities or intellectual property rights regarding this script
# ---------------------------------------------------------------------------------
# Name: speedtest
# Description: Uses speedtest.net
# Author: HitaloSama
# Commands:
# .speedtest
# ---------------------------------------------------------------------------------


#    Friendly Telegram (telegram userbot)
#    Copyright (C) 2018-2019 The Authors

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.

#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.

# requires: speedtest-cli>=2.1.0

import logging

import speedtest

from .. import loader, utils

logger = logging.getLogger(__name__)


@loader.tds
class SpeedtestMod(loader.Module):
    """Uses speedtest.net"""

    strings = {
        "name": "Speedtest",
        "running": "<b>Running speedtest...</b>",
        "results": "<b>Speedtest Results:</b>",
        "results_download": "<b>Download:</b> <code>{}</code> <b>MiB/s</b>",
        "results_upload": "<b>Upload:</b> <code>{}</code> <b>MiB/s</b>",
        "results_ping": "<b>Ping:</b> <code>{}</code> <b>ms</b>",
    }

    async def speedtestcmd(self, message):
        """Tests your internet speed"""
        await utils.answer(message, self.strings("running", message))
        args = utils.get_args(message)
        servers = []
        for server in args:
            try:
                servers += [int(server)]
            except ValueError:
                logger.warning("server failed")
        results = await utils.run_sync(self.speedtest, servers)
        ret = self.strings("results", message) + "\n\n"
        ret += (
            self.strings("results_download", message).format(
                round(results["download"] / 2**20, 2)
            )
            + "\n"
        )
        ret += (
            self.strings("results_upload", message).format(
                round(results["upload"] / 2**20, 2)
            )
            + "\n"
        )
        ret += (
            self.strings("results_ping", message).format(round(results["ping"], 2))
            + "\n"
        )
        await utils.answer(message, ret)

    def speedtest(self, servers):
        speedtester = speedtest.Speedtest()
        speedtester.get_servers(servers)
        speedtester.get_best_server()
        speedtester.download(threads=None)
        speedtester.upload(threads=None)
        return speedtester.results.dict()
